#version 330 core
layout (location = 0) in vec3 vertex;
layout (location = 1) in vec4 xyzs;
layout (location = 2) in vec4 color;

out vec2 TexCoords;
out vec4 ParticleColor;


uniform vec3 Camera_right;
uniform vec3 Camera_up;
uniform mat4 VP;


void main ()
{
	float particleSize = xyzs.w;
	vec3 particleCenter = xyzs.xyz;

	vec3 vertexPosition = particleCenter
	+ Camera_right * vertex.x * particleSize
	+ Camera_up * vertex.y * particleSize;

	gl_Position = VP * vec4(vertexPosition, 1.0f);

	TexCoords = vertex.xy + vec2(0.5, 0.5);
	ParticleColor = color;
}