#version 330 core
layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aTexCoords;
layout (location = 3) in ivec3 BoneIDs;
layout (location = 4) in vec3 Weights;

out vec2 TexCoords;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 bones[21];

void main()
{
    TexCoords = aTexCoords;
	
	mat4 BoneTransform = bones[BoneIDs[0]] * Weights[0];
	BoneTransform += bones[BoneIDs[1]] * Weights[1];
    BoneTransform += bones[BoneIDs[2]] * Weights[2];

	vec4 PosL = BoneTransform * vec4(aPos, 1.0);

	gl_Position = projection * view * model * PosL + vec4(0.0,-10.0,0.0,0.0);
}